volatile unsigned int sindat[180], pwmdat[180];
unsigned int angl;
unsigned int i;
unsigned short freq = 50;                                                       //set frequency of sin wave

const float pi = 3.1416;
      float uf;
void main() 
{
// Calculate SIN Table 3 Phase -------------------------------------------------
 uf = 500 * ((float)freq / 50);                                                 //Calculate U/f scalar factor
 for (i=0; i<60; i++) {                                                         //Calculate phase U table
      angl = i * 6;
      sindat[3 * i] =  uf +  uf * (sin ((angl * pi)/180));
     }
 for (i=0; i<60; i++) {                                                         //Calculate phase V table
      angl = (i * 6) + 120 ;
      sindat[(3 * i) + 1] =  uf +  uf * (sin ((angl * pi)/180));
     }
 for (i=0; i<60; i++) {                                                         //Calculate phase W table
      angl = (i * 6) + 240;
      sindat[(3 * i) + 2] =  uf +  uf * (sin ((angl * pi)/180));
     }
// Timer 1 Setup ---------------------------------------------------------------
 GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_13);

 RCC_APB2ENRbits.TIM1EN =         1;                                            //Timer 1 Clock
 RCC_APB2ENRbits.AFIOEN =         1;                                            //Alterbate Function Clock
 RCC_APB2ENRbits.IOPAEN =         1;                                            //GPIO PORTA Clock
 RCC_APB2ENRbits.IOPBEN =         1;                                            //GPIO PORTB Clock
 
 GPIOa_CRHbits.MODE8 =            0b11;                                         //CONFIG PA8 as Push-Pull AF_out
 GPIOa_CRHbits.CNF8  =            0b10;                                         //CONFIG PA8 as 2MHz output
 GPIOa_CRHbits.MODE9 =            0b11;                                         //CONFIG PA9 as Push-Pull AF_out
 GPIOa_CRHbits.CNF9  =            0b10;                                         //CONFIG PA9 as 2MHz output
 GPIOa_CRHbits.MODE10 =           0b11;                                         //CONFIG PA9 as Push-Pull AF_out
 GPIOa_CRHbits.CNF10  =           0b10;                                         //CONFIG PA9 as 2MHz output

 GPIOb_CRHbits.MODE13 =           0b11;                                         //CONFIG PB13 as Push-Pull AF_out
 GPIOb_CRHbits.CNF13  =           0b10;                                         //CONFIG PB13 as 2MHz output
 GPIOb_CRHbits.MODE14 =           0b11;                                         //CONFIG PB14 as Push-Pull AF_out
 GPIOb_CRHbits.CNF14  =           0b10;                                         //CONFIG PB14 as 2MHz output
 GPIOb_CRHbits.MODE15 =           0b11;                                         //CONFIG PB15 as Push-Pull AF_out
 GPIOb_CRHbits.CNF15  =           0b10;                                         //CONFIG PB15 as 2MHz outputt

 TIM1_CR1bits.CEN =               0;                                            //Disable Timer 1 counter
 TIM1_CR1bits.DIR_ =              0;                                            //Up Counting timer mode
//TIM1_CR1bits.CMS =               0b11;                                         //Center Aligned Mode  (F = F/2 !!!!)
 
 TIM1_ARR =                       1000;                                         //Load ARR register value
 TIM1_PSC =                       11;                                           //Load PSC register value
 TIM1_CR1bits.ARPE =              1;                                            //Load ARR register preload mode

 TIM1_CCMR1_Outputbits.OC1M =     0x6;                                          // Set CH1 pwm mode 1
 TIM1_CCMR1_Outputbits.OC2M =     0x6;                                          // Set CH1 pwm mode 1
 TIM1_CCMR2_Outputbits.OC3M =     0x6;                                          // Set CH1 pwm mode 1
 
 TIM1_CCMR1_Outputbits.OC1PE =    1;                                            //Load CCR1 register preload mode
 TIM1_CCMR1_Outputbits.OC2PE =    1;                                            //Load CCR2 register preload mode
 TIM1_CCMR2_Outputbits.OC3PE =    1;                                            //Load CCR3 register preload mode
 
 TIM1_CCERbits.CC1E =             1;                                            //Enable CCE1 output
 TIM1_CCERbits.CC1NE =            1;                                            //Enable CCE1N output
 TIM1_CCERbits.CC2E =             1;                                            //Enable CCE2 output
 TIM1_CCERbits.CC2NE =            1;                                            //Enable CCE2N output
 TIM1_CCERbits.CC3E =             1;                                            //Enable CCE1 output
 TIM1_CCERbits.CC3NE =            1;                                            //Enable CCE2N output
 
 TIM1_CCERbits.CC1P =             1;                                            //Active polarity CCE1 - low
 TIM1_CCERbits.CC1NP =            1;                                            //Active low polarity CCE1N - low
 TIM1_CCERbits.CC2P =             1;                                            //Active polarity CCE2 - low
 TIM1_CCERbits.CC2NP =            1;                                            //Active low polarity CCE2N - low
 TIM1_CCERbits.CC3P =             1;                                            //Active polarity CCE2 - low
 TIM1_CCERbits.CC3NP =            1;                                            //Active low polarity CCE2N - low

 TIM1_BDTRbits.OSSR =             1;                                            //Off-state selection for Run mode low
 TIM1_BDTRbits.DTG =              0x4D;                                         //Set Dead TIME 77ns
 TIM1_BDTRbits.MOE =              1;                                            //Set main output
 TIM1_CR1bits.ARPE =              1;                                            //Set timer auto reload
 TIM1_CCR1 = 10;
 TIM1_CCR2 = 10;
 TIM1_CCR3 = 10;
 NVIC_IntEnable(IVT_INT_TIM1_UP);                                               //Enable Interrupt vector IVT_INT_TIM1_UP
 TIM1_DIERbits.UIE =              1;                                            //Enable Interrupt TIM UP
 
 TIM1_CR1.CEN =                   1;                                            //Enable Timer 1 counter
//Timer 1 Setup DMA BURST ------------------------------------------------------
 TIM1_DCRbits.DBA =              0x0D;                                          //DMA Offset to TIM1_CCR reg
 TIM1_DCRbits.DBL =              0x02;                                          //3 DMA Transaction as one
// Timer 3 Setup ---------------------------------------------------------------
 RCC_APB1ENR.TIM3EN =            1;                                             //Timer 1 Clock
 TIM3_CR1bits.CEN =              0;                                             //Disable Timer 3 counter
 TIM3_PSC =                      7;                                             //Load PSC register value
 TIM3_ARR =                      ((50 / freq) * 1000) - 1;;                     //Load ARR register value
 TIM3_CR1bits.ARPE =             1;                                             //Load ARR register preload mode
 TIM3_DIERbits.UDE =             1;                                             //Enable DMA REQ RIM3 (DMA 2 CH 3)
 TIM3_DIERbits.UIE =             1;                                             //Enable Interrupt TIM3 UP
 NVIC_IntEnable(IVT_INT_TIM3);                                                  //Enable Interrupt vector IVT_INT_TIM3
 TIM3_CR1.CEN = 1;                                                              //Enable Timer 3 counter
//DMA1 Setup -------------------------------------------------------------------
 RCC_AHBENRbits.DMA1EN =          1;                                            //DMA1 Clock
 DMA1_CPAR3 =                     (unsigned long)&TIM1_DMAR;
 DMA1_CMAR3 =                     (unsigned long)&sindat[0];
 DMA1_CNDTR3 =                    180;
 DMA1_CCR3bits.MINC =             1;                                            //Increment memory pointer
 DMA1_CCR3bits.CIRC =             1;                                            //Cycle mode
 DMA1_CCR3bits.DIR_=              1;                                            //From mem to per
 //DMA1_CCR2bits.MSIZE =            0b01;                                       //MEM DATA Lenth 16bit (BUG IN COMPILER/DEF !!!!!)
 //DMA1_CCR2bits.PSIZE =            0b01;                                       //PER DATA Lenth 16bit (BUG IN COMPILER/DEF !!!!!)
 DMA1_CCR3 |=                     0b0000010100000000;                           //SET MEM and PER Lenth 16bit directly
 DMA1_CCR3bits.EN =               1;                                            //Start 3ch DMA1
//------------------------------------------------------------------------------
  while(1)
  {
  }
}

void Timer3_interrupt() iv IVT_INT_TIM3 {
  TIM3_SR.UIF = 0;
}

void Timer1_interrupt() iv IVT_INT_TIM1_UP {
  TIM1_SR.UIF = 0;
}